com.hazelcast.jet.core

## Enum Edge.RoutingPolicy

- java.lang.Object
- - java.lang.Enum<Edge.RoutingPolicy>
  - - com.hazelcast.jet.core.Edge.RoutingPolicy

- All Implemented Interfaces:
    Serializable, Comparable<Edge.RoutingPolicy>
  Enclosing class:
    Edge

      public static enum Edge.RoutingPolicy
      extends Enum<Edge.RoutingPolicy>
      implements Serializable

  An edge describes a connection from many upstream processors to many downstream processors. The routing policy decides where exactly to route each particular item emitted from an upstream processor. To simplify the reasoning we introduce the concept of the set of candidate downstream processors, or the candidate set for short. On a local edge the candidate set contains only local processors and on a distributed edge it contain all the processors.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BROADCAST` Each item is sent to all candidate processors.
    `ISOLATED` Like `UNICAST`, but guarantees that any given downstream processor receives data from exactly one upstream processor.
    `PARTITIONED` Each item is sent to the one processor responsible for the item's partition ID.
    `UNICAST` For each item a single destination processor is chosen from the candidate set, with no restriction on the choice.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Edge.RoutingPolicy` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static Edge.RoutingPolicy[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### UNICAST

          public static final Edge.RoutingPolicy UNICAST

      For each item a single destination processor is chosen from the candidate set, with no restriction on the choice.

    - #### ISOLATED

          public static final Edge.RoutingPolicy ISOLATED

      Like `UNICAST`, but guarantees that any given downstream processor receives data from exactly one upstream processor. This is needed in some DAG setups to apply selective backpressure to individual upstream source processors.

      The downstream's local parallelism must not be less than the upstream's. This policy is only available on a local edge.

    - #### PARTITIONED

          public static final Edge.RoutingPolicy PARTITIONED

      Each item is sent to the one processor responsible for the item's partition ID. On a distributed edge the processor is unique across the cluster; on a non-distributed edge the processor is unique only within a member.

    - #### BROADCAST

          public static final Edge.RoutingPolicy BROADCAST

      Each item is sent to all candidate processors.

  - ### Method Detail

    - #### values

          public static Edge.RoutingPolicy[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Edge.RoutingPolicy c : Edge.RoutingPolicy.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Edge.RoutingPolicy valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Copyright © 2018. All rights reserved.